diff -urN microwindows-0.91/src/nanox/srvclip2.c microwindows-0.91.g100/src/nanox/srvclip2.c
--- microwindows-0.91/src/nanox/srvclip2.c	2007-06-17 21:56:40.000000000 +0200
+++ microwindows-0.91.g100/src/nanox/srvclip2.c	2007-06-17 20:41:26.000000000 +0200
@@ -10,6 +10,691 @@
 #include <stdlib.h>
 #include "serv.h"
 
+
+//*REM BEGIN*/
+/*  Quick and dirty stolen from devrgn.c
+ *  
+ *  1 if two RECTs overlap.
+ *  0 if two RECTs do not overlap.
+ */
+#define EXTENTCHECK(r1, r2) \
+	((r1)->right > (r2)->left && \
+	 (r1)->left < (r2)->right && \
+	 (r1)->bottom > (r2)->top && \
+	 (r1)->top < (r2)->bottom)
+
+
+/* This function takes a map of pixels which are visible.  
+ * The map is like a region, so its a rectangle with a
+ * position on the screen. The map 
+ * is a simple array of chars. A 0xff means the pixel is
+ * visible. All other values are invisible and wont be printed
+ * by the screendriver (as far as the SetClipmap function is used before). 
+ *  
+ * The pixmap is the analogon to vismap. Our job here is to substract 
+ * all visible parts of pixmap.
+ *  
+ * @param vismap        pointer to map with visible pixels
+ * @param vismap_x      absolute x-position of vismap
+ * @param vismap_y      absolute y-position of vismap
+ * @param vismap_height height of vismap
+ * @param vismap_width  width  of vismap
+ * @param pixmap        pointer to pixmap we have to substract
+ * @param pixmap_x      absolute left position of pixmap
+ * @param pixmap_y      absolute top  position of pixmap
+ * @param pixmap_width  width  of pixmap
+ * @param pixmap_height height of pixmap
+ *
+ */
+void GsClipPixmap( char* vismap,
+		   GR_COORD	vismap_x,
+		   GR_COORD	vismap_y,
+		   GR_COORD	vismap_width,
+		   GR_COORD	vismap_height,
+		   char*        pixmap, 
+		   GR_COORD	pixmap_x,
+		   GR_COORD	pixmap_y,
+		   GR_COORD	pixmap_width,
+		   GR_COORD	pixmap_height)
+{
+  //firstly we fill a MWRECT structure
+  MWRECT vismaprect={vismap_x,vismap_y,vismap_x+vismap_width,vismap_y+vismap_height};
+  MWRECT pixmaprect ={pixmap_x,pixmap_y,pixmap_x+pixmap_width,pixmap_y+pixmap_height};
+
+  //check if pixmap does overlap our pixmap
+  if(!(EXTENTCHECK(&vismaprect,&pixmaprect)))
+    return;
+
+  //cut away all parts which are not in vismap
+  if(pixmaprect.left<vismaprect.left)
+    pixmaprect.left=vismaprect.left;
+  if(pixmaprect.right>vismaprect.right)
+    pixmaprect.right=vismaprect.right;
+  if(pixmaprect.top<vismaprect.top)
+    pixmaprect.top=vismaprect.top;
+  if(pixmaprect.bottom>vismaprect.bottom)
+    pixmaprect.bottom=vismaprect.bottom;
+
+  //brief description of whats calculated here
+  //
+  //
+  //                                 pixmap
+  //                              |--------------------
+  //pixmaprelxbegin              >|<                  |
+  //                  ------------|--------------     |
+  //pixmaprelxend     |           |<----------->|     |
+  //                  |           |             |     |
+  //vismaprelxbegin   |<--------->|             |     |
+  //                  |           |             |     |
+  //                  |           |--------------------
+  //vismaprelxend     |<----------------------->|
+  //                  |                         |
+  //                  |                         |
+  //                  |                         |
+  //                  |vismap                   |
+  //                  ---------------------------
+  //
+  //
+  //
+  GR_COORD vismaprelxbegin=pixmaprect.left-vismaprect.left;
+  GR_COORD vismaprelybegin=pixmaprect.top-vismaprect.top;
+
+  //GR_COORD vismaprelxend=pixmaprect.right-vismaprect.left;
+  //GR_COORD vismaprelyend=pixmaprect.bottom-vismaprect.top;
+
+  GR_COORD pixmaprelxbegin=pixmaprect.left-/*minx*/pixmap_x;
+  GR_COORD pixmaprelybegin=pixmaprect.top-/*miny*/pixmap_y;
+
+  GR_COORD pixmaprelxend=pixmaprelxbegin+(pixmaprect.right-pixmaprect.left);
+  GR_COORD pixmaprelyend=pixmaprelybegin+(pixmaprect.bottom-pixmaprect.top);
+
+  char        *datasrc=pixmap;
+  char        *datadst=vismap; 
+
+  int xi,yi;
+  for(yi=0;yi<(pixmaprelyend-pixmaprelybegin);yi++)
+    {
+      GR_COORD pixmaprely=pixmaprelybegin+yi;
+      GR_COORD pixmaprelx=pixmaprelxbegin;
+
+      GR_COORD vismaprely=vismaprelybegin+yi;
+      GR_COORD vismaprelx=vismaprelxbegin;
+
+      datasrc=&pixmap[(pixmaprely*pixmap_width)+pixmaprelx];
+      datadst=&vismap[(vismaprely*vismap_width)+vismaprelx];
+      for(xi=0;xi<pixmaprelxend-pixmaprelxbegin;xi++)
+	{
+	  //*datadst=(*datadst)&(*datasrc);
+	  if((*datadst)&&(!(*datasrc)))
+	    *datadst=0xff;
+	  else
+	    *datadst=0x00;
+
+	  datadst++;
+	  datasrc++;
+	}
+    }
+  return;
+}
+//*REM END*/
+
+/*
+ * This function checks if wp is ovelaping the clipregion vis and substracts
+ * the overlaping part if wp has a nontransparent background. If wp is 
+ * transparent, GsClipPixmap is called which substracts all visible pixels of 
+ * wp from vismap. This recursive function calls itself again for all childs of
+ * wp if wp is transparent. Recursion is stopped with the first nontransparent child.
+ * @param wporig        Original window which should be clipped.             
+ * @param wp            Window to examine.           
+ * @param vis           Clip region.
+ * @param x             X position of area to clip. This position is relative to the root window.
+ * @param y             Y position of area to clip. This position is relative to the root window.
+ * @param with          Width of area to clip.
+ * @param height        Height of Area to clip.
+ * @param RToclip       Area where clipping is needed.  
+ * @param r             Temp region.    
+ * @param flags         flags.
+ *
+ */
+
+void GrSetClipWindowRec(GR_WINDOW *wporig,GR_WINDOW *wp,MWCLIPREGION *vis,MWCLIPMAP *vismap,GR_COORD x,GR_COORD y,GR_COORD width,GR_COORD height,MWRECT *RToClip, MWCLIPREGION *r, int flags)
+{
+  GR_SIZE  bs = wp->bordersize;
+  GR_COORD minx = wp->x - bs;
+  GR_COORD miny = wp->y - bs;
+  GR_COORD maxx = wp->x + wp->width + bs;
+  GR_COORD maxy = wp->y + wp->height + bs;
+  GR_WINDOW *sibwp=NULL;
+
+  if (!wp->realized || !wp->output)
+    return;
+  
+  GdSetRectRegion(r, minx, miny, maxx, maxy);
+
+  //if our window is not in the area we want to draw later, all childs will too, so we return
+  if(RToClip &&(!(EXTENTCHECK(RToClip, &r->extents))))
+    return;
+
+  //We have to distingish two situations:
+  //1.) The overlaping window has a non transparent background.
+  //    In this case we dont substract any pixels but we substract 
+  //    the whole region from vis to prevent the draw routines from
+  //    drawing here.
+  //2.) The overlaping window has a transparent background.
+  //    There are parts in vis we have to clip, and parts 
+  //    we must not clip, since ther may be transparent
+  //    pixels. All the transparent parts are described by 
+  //    the windows' alpha channel in wp->alpha. 
+  //    So we simply substract wp->alpha from vismap.
+  //
+  //If no alpha channel is found, we simply skip this.
+  //
+  //
+  if (((wp->background & 0xff000000)==0)||(wp->props & GR_WM_PROPS_APPMASK && wp->children && MWA(wp->children->background)==0))
+    {
+      if(wp->alpha && vismap)
+	{
+	  vismap->dirty=1;
+	  GsClipPixmap(vismap->clipmap,
+		       vismap->clipregion->left/*x*/,
+		       vismap->clipregion->top/*y*/,
+		       vismap->clipregion->right-vismap->clipregion->left/*width*/,
+		       vismap->clipregion->bottom-vismap->clipregion->top/*height*/,
+		       wp->alpha,minx,miny,maxx-minx,maxy-miny
+		       );
+	  if(wp->bgpixmap && wp->bgpixmap->alpha)
+	    {
+	      minx = wp->x;
+	      miny = wp->y;
+	      maxx = wp->x + wp->bgpixmap->width;
+	      maxy = wp->y + wp->bgpixmap->height;
+	      GsClipPixmap(vismap->clipmap,
+			   vismap->clipregion->left/*x*/,
+			   vismap->clipregion->top/*y*/,
+			   vismap->clipregion->right-vismap->clipregion->left/*width*/,
+			   vismap->clipregion->bottom-vismap->clipregion->top/*height*/,
+			   wp->bgpixmap->alpha,minx,miny,maxx-minx,maxy-miny
+			   );
+	    }
+	}
+    }
+  else
+    {
+
+      GdSubtractRegion(vis, vis, r);
+      /* FIXME: shaped windows with borders won't work */
+      if (wp->clipregion) {
+	/* FIXME: can user set invalid clipregion here? */
+	GdOffsetRegion(wp->clipregion,
+		       wp->x, wp->y);
+	GdSubtractRegion(vis, vis, wp->clipregion);
+	GdOffsetRegion(wp->clipregion,
+		       -wp->x, -wp->y);
+      }
+    }
+
+  //Now do the same for all childs. We can omit this if wp does not have a transparent bg
+  if (((wp->background & 0xff000000)==0)||(wp->props & GR_WM_PROPS_APPMASK && wp->children && MWA(wp->children->background)==0))
+    {
+      if(!(flags & GR_MODE_EXCLUDECHILDREN))
+	{
+	  for (sibwp=wp->children; sibwp; sibwp = sibwp->siblings) {
+	    if (!sibwp->realized || !sibwp->output)
+	      continue;
+	    GrSetClipWindowRec(wporig,sibwp,vis,vismap,x,y,width,height,RToClip,r,flags);
+	  }
+	}
+    }
+}
+
+/*
+ * Set the clip rectangles for a window taking into account other
+ * windows that may be obscuring it.  The windows that may be obscuring
+ * this one are the siblings of each direct ancestor which are higher
+ * in priority than those ancestors.  Also, each parent limits the visible
+ * area of the window.  The clipping is not done if it is already up to
+ * date of if the window is not outputtable.
+ *
+ * REM: This functions does not do the substraction any more, but is calling 
+ * GsSetClipWindowRec instead which will also check all childs recursively.
+ */
+
+#if defined(TRANS_COLOR)
+//*REM*/ RToClip indicates the area, wher clipping is important. We dont have to examin
+//*REM*/ the whole Area if we draw there in a small piece (described by RToClip). 
+void
+GsSetClipWindow(GR_WINDOW *wp, MWCLIPREGION *userregion, int flags, /*REM*/MWRECT* RToClip)
+{
+	GR_WINDOW	*orgwp;		/* original window pointer */
+	GR_WINDOW	*pwp;		/* parent window */
+	GR_WINDOW	*sibwp;		/* sibling windows */
+	GR_COORD	diff;		/* difference in coordinates */
+	GR_COORD	x, y, width, height;
+	MWCLIPREGION	*vis, *r;
+	MWCLIPMAP *          vismap=NULL;
+	/*REM*/struct timeval tv1, tv2;
+	/*REM*/struct timezone tz;
+
+	if (!wp->realized || !wp->output)
+		return;
+
+	clipwp = wp;
+
+	/*
+	 * Start with the rectangle for the complete window.
+	 * We will then cut pieces out of it as needed.
+	 */
+	x = wp->x;
+	y = wp->y;
+	width = wp->width;
+	height = wp->height;
+
+	/*
+	 * First walk upwards through all parent windows,
+	 * and restrict the visible part of this window to the part
+	 * that shows through all of those parent windows.
+	 */
+	pwp = wp;
+	while (pwp != rootwp) {
+		pwp = pwp->parent;
+
+		diff = pwp->x - x;
+		if (diff > 0) {
+			width -= diff;
+			x = pwp->x;
+		}
+
+		diff = (pwp->x + pwp->width) - (x + width);
+		if (diff < 0)
+			width += diff;
+
+		diff = pwp->y - y;
+		if (diff > 0) {
+			height -= diff;
+			y = pwp->y;
+		}
+
+		diff = (pwp->y + pwp->height) - (y + height);
+		if (diff < 0)
+			height += diff;
+	}
+
+	/*
+	 * If the window is completely clipped out of view, then
+	 * set the clipping region to indicate that.
+	 */
+	if (width <= 0 || height <= 0) {
+		GdSetClipRegion(clipwp->psd, NULL);
+		return;
+	}
+
+	/*
+	 * Allocate region to clipped size of window,
+	 * intersect with user window clip region.
+	 */
+	vis = GdAllocRectRegion(x, y, x+width, y+height);
+
+	if(!(flags & GR_MODE_EXCLUDECHILDREN))
+	  {
+	    if(RToClip)
+	      {
+		vismap=GdAllocClipMap(RToClip->left,
+				      RToClip->top,
+				      RToClip->right,
+				      RToClip->bottom,
+				      0xff);
+	      }
+	    else
+	      {
+		vismap=GdAllocClipMap(x,y,x+width, y+height,0xff); 
+	      }
+	  }
+
+	if (wp->clipregion) {
+		GdOffsetRegion(wp->clipregion, wp->x, wp->y);
+		GdIntersectRegion(vis, vis, wp->clipregion);
+		GdOffsetRegion(wp->clipregion, -wp->x, -wp->y);
+	}
+
+	/*
+	 * 
+	 * We are in the clipping function here. So 
+	 * someone wants to print some pixels and  
+	 * he only wants it in the region 
+	 * described by RToClip. So we can finish our work here 
+	 * if RToClip does not overlap vis. Although the clipmap 
+	 * is not correct, this does not matter since anyone 
+	 * will draw outside RToClip in near future.
+	 */
+	if(RToClip && (!(EXTENTCHECK(&vis->extents, RToClip))))
+	  goto end;
+
+
+	/* 
+	 * Allocate temp region
+	 */
+	r = GdAllocRegion();
+
+
+	/*
+	 * Now examine all windows that obscure this window, and
+	 * for each obscuration, break up the clip rectangles into
+	 * the smaller pieces that are still visible.  The windows
+	 * that can obscure us are the earlier siblings of all of
+	 * our parents.
+ 	 */
+	orgwp = wp;
+	pwp = wp;
+	while (pwp != NULL) {
+		wp = pwp;
+		pwp = wp->parent;
+
+		if(!pwp) {
+			/* We're clipping the root window*/
+			if (!(flags & GR_MODE_EXCLUDECHILDREN))
+				/* start with root's children*/
+				sibwp = rootwp->children;
+			else sibwp = NULL;	 /* no search*/
+			wp = NULL;		 /* search all root's children*/
+		} else {
+			sibwp = pwp->children;	 /* clip siblings*/
+		}
+
+		for (; sibwp != wp; sibwp = sibwp->siblings) {
+			if (!sibwp->realized || !sibwp->output)
+				continue;
+			GrSetClipWindowRec(orgwp,sibwp,vis,vismap,x,y,width,height,RToClip,r,flags);
+		}
+		/* if not clipping the root window, stop when you reach it*/
+		if (pwp == rootwp)
+			break;
+	}
+
+	wp = orgwp;
+	/*
+	 * If not the root window, clip all children.
+	 * (Root window's children are are clipped above)
+	 */
+	if(wp != rootwp && !(flags & GR_MODE_EXCLUDECHILDREN)) {
+		for (sibwp=wp->children; sibwp; sibwp = sibwp->siblings) {
+			if (!sibwp->realized || !sibwp->output)
+			  continue;
+			GrSetClipWindowRec(orgwp,sibwp,vis,vismap,x,y,width,height,RToClip,r,flags);
+		}
+	}
+
+	/*
+	 * Intersect with user region, if set.
+	 */
+	if (userregion) {
+		/* temporarily offset region by window coordinates*/
+		GdOffsetRegion(userregion, wp->x, wp->y);
+		GdIntersectRegion(vis, vis, userregion);
+		GdOffsetRegion(userregion, -wp->x, -wp->y);
+	}
+
+
+	/*
+	 * Set the clip region (later destroy handled by GdSetClipRegion)
+	 */
+	GdSetClipRegion(clipwp->psd, vis);
+
+	/*
+	 * Destroy temp region
+	 */
+	GdDestroyRegion(r);
+
+ end:
+	/*
+	 * Set the clip region (later destroy handled by GdSetClipRegion)
+	 */
+	GdSetClipMap(vismap);
+}
+
+/*
+ * This function is similar to GsSetClipWindow. It does not allocate a complete
+ * new region each time region but uses the current clipregion. Calling
+ * this function with NULL for wp, will cause an allocation of a new   
+ * clip region whith the same size than rootwp. This region is set as new clip region.
+ * All future calls with wp!-NULL will cause a modification of this region.
+ */
+void
+GsSetClipWindowPart(GR_WINDOW *wp, MWCLIPREGION *userregion, int flags, /*REM*/MWRECT* RToClip)
+{
+	GR_WINDOW	*orgwp;		/* original window pointer */
+	GR_WINDOW	*pwp;		/* parent window */
+	GR_WINDOW	*sibwp;		/* sibling windows */
+	GR_COORD	diff;		/* difference in coordinates */
+	GR_COORD	x, y, width, height;
+
+	static MWCLIPREGION *r=NULL;
+	MWCLIPREGION *vis=NULL;
+	MWCLIPMAP    *vismap=NULL;
+
+	if(!wp)
+	  {
+	    /*
+	     * Allocate region to clipped size of window,
+	     */
+	    vis = GdAllocRectRegion(0, 0, rootwp->width, rootwp->height);
+
+	    /*
+	     * Allocate vismap
+	     */
+	    vismap=GdAllocClipMap(0,0,rootwp->width, rootwp->height,0xff); 
+
+	    /* 
+	     * Allocate temp region
+	     */
+	    if(r) GdDestroyRegion(r);
+	    r = GdAllocRegion();
+
+	    /*
+	     * Set the clip region (later destroy handled by GdSetClipRegion)
+	     * GdSetClipRegion does not destroy the region if the clipregion set is the same we handle over
+	     */
+	    GdSetClipRegion(rootwp->psd, vis);
+
+	    /*
+	     * Set the clip region (later destroy handled by GdSetClipMap)
+	     * GdSetClipMap does not destroy the region if the clipmap set is the same we handle over
+	     */
+	    GdSetClipMap(vismap);
+	    
+
+	    return;
+	  }
+	else
+	  {
+	    if (!wp->realized || !wp->output)
+		return;
+
+
+	    /*
+	     * Get current region since we want to add something here
+	     */
+	    vis = GdGetClipRegion();
+
+	    /*
+	     * Get current vismap since we want to add something here
+	     */
+	    vismap=GdGetClipMap(); 
+
+	    /* someone did forget to do an initial call? */
+	    if(!vis || ! vismap)
+	      return;
+
+	    clipwp = wp;
+
+	    /*
+	     * Start with the rectangle for the complete window.
+	     * We will then cut pieces out of it as needed.
+	     */
+	    /*
+	      x = wp->x;
+	      y = wp->y;
+	      width = wp->width;
+	      height = wp->height;
+	    */
+
+	    x = RToClip->left;
+	    y = RToClip->top;
+	    width = RToClip->right-RToClip->left;
+	    height = RToClip->bottom-RToClip->top;
+
+
+	    /*
+	     * First walk upwards through all parent windows,
+	     * and restrict the visible part of this window to the part
+	     * that shows through all of those parent windows.
+	     */
+	    pwp = wp;
+	    while (pwp != rootwp) {
+	      pwp = pwp->parent;
+	      
+	      diff = pwp->x - x;
+	      if (diff > 0) {
+		width -= diff;
+		x = pwp->x;
+	      }
+	      
+	      diff = (pwp->x + pwp->width) - (x + width);
+	      if (diff < 0)
+		width += diff;
+	      
+	      diff = pwp->y - y;
+	      if (diff > 0) {
+		height -= diff;
+		y = pwp->y;
+	      }
+	      
+	      diff = (pwp->y + pwp->height) - (y + height);
+	      if (diff < 0)
+		height += diff;
+	    }
+
+	    /*
+	     * If the window is completely clipped out of view, then
+	     * set the clipping region to indicate that.
+	     */
+	    if (width <= 0 || height <= 0) {
+	      GdSetRectRegion(r, RToClip->left, RToClip->top, RToClip->right, RToClip->bottom);
+	      GdSubtractRegion(vis, vis, r);
+	      goto end;
+	    }
+
+	    /*
+	     * If the window is partially  clipped out of view, then
+	     * subtract the visible part from clip region.
+	     */
+	    if ((x != RToClip->left) ||	(y != RToClip->top)  ||	
+		(width  != (RToClip->right-RToClip->left)) ||
+		(height != (RToClip->bottom-RToClip->top))){
+
+	      MWCLIPREGION *rhelp = GdAllocRegion();
+	      GdSetRectRegion(rhelp, x, y, x+width, y+height);
+	      GdSetRectRegion(r, RToClip->left, RToClip->top, RToClip->right, RToClip->bottom);
+
+	      //r holds now the clipped out part
+	      GdSubtractRegion(r, r, rhelp);
+
+	      //substract it from vis
+	      GdSubtractRegion(vis, vis, r);
+
+	      GdDestroyRegion(rhelp);
+	    }
+
+	    if (wp->clipregion) {
+	      GdOffsetRegion(wp->clipregion, wp->x, wp->y);
+	      GdIntersectRegion(vis, vis, wp->clipregion);
+	      GdOffsetRegion(wp->clipregion, -wp->x, -wp->y);
+	    }
+
+	    /*
+	     * 
+	     * We are in the clipping function here. So 
+	     * someone wants to print some pixels and  
+	     * he only wants it in the region 
+	     * described by RToClip. So we can finish our work here 
+	     * if RToClip does not overlap vis. Although the clipmap 
+	     * is not correct, this does not matter since anyone 
+	     * will draw outside RToClip in near future.
+	     */
+	    if(RToClip && (!(EXTENTCHECK(&vis->extents, RToClip))))
+	      return;
+	    
+	    /*
+	     * Now examine all windows that obscure this window, and
+	     * for each obscuration, break up the clip rectangles into
+	     * the smaller pieces that are still visible.  The windows
+	     * that can obscure us are the earlier siblings of all of
+	     * our parents.
+	     */
+
+	    if(flags&GR_MODE_THISWP)
+	      {
+		GrSetClipWindowRec(wp,wp,vis,vismap,/*x*/0,/*y*/0,rootwp->width,rootwp->height,RToClip,r,flags);
+		goto end;
+	      }
+
+	    orgwp = wp;
+	    if(!(flags&GR_MODE_DIRECTCHILD))
+	      {
+		pwp = wp;
+		while (pwp!=rootwp) {
+		  wp = pwp;
+		  pwp = wp->parent;
+		  
+		  sibwp = pwp->children;	 /* clip siblings*/
+		  
+		  for (; sibwp != wp; sibwp = sibwp->siblings) {
+		    if (!sibwp->realized || !sibwp->output)
+		      continue;
+
+		    /* if GR_MODE_DIRECTSIBLING we clip the wp directly to the right only */
+		    if(((flags&GR_MODE_DIRECTSIBLING)&&(sibwp->siblings==orgwp)) || (!(flags&GR_MODE_DIRECTSIBLING)))
+		      GrSetClipWindowRec(orgwp,sibwp,vis,vismap,/*x*/0,/*y*/0,rootwp->width,rootwp->height,RToClip,r,flags);
+		  }
+		  
+		  /* if GR_MODE_DIRECTSIBLING is set we dont need to go up */
+		  if (flags&GR_MODE_DIRECTSIBLING)
+		    break;
+		}
+	      }
+
+	    wp = orgwp;
+	    /*
+	     * If not the root window, clip all children.
+	     * (Root window's children are are clipped above)
+	     */
+	    if((!(flags & GR_MODE_EXCLUDECHILDREN))|| (flags & GR_MODE_DIRECTCHILD)) {
+	      for (sibwp=wp->children; sibwp; sibwp = sibwp->siblings) {
+		if (!sibwp->realized || !sibwp->output)
+		  continue;
+		if(!(flags & GR_MODE_DIRECTCHILD) || ((flags & GR_MODE_DIRECTCHILD)&& !sibwp->siblings))
+		  GrSetClipWindowRec(orgwp,sibwp,vis,vismap,/*x*/0,/*y*/0,rootwp->width,rootwp->height,RToClip,r,flags);
+	      }
+	    }
+
+	  end:
+	    
+	    /*
+	     * Intersect with user region, if set.
+	     */
+	    if (userregion) {
+	      /* temporarily offset region by window coordinates*/
+	      GdOffsetRegion(userregion, wp->x, wp->y);
+	      GdIntersectRegion(vis, vis, userregion);
+	      GdOffsetRegion(userregion, -wp->x, -wp->y);
+	    }
+	  }
+	/* vismap is already set with the initial call */
+	/* clipreagion must be set again */
+	GdSetClipRegion(clipwp->psd, vis);
+}
+
+#else
+
 /*
  * Set the clip rectangles for a window taking into account other
  * windows that may be obscuring it.  The windows that may be obscuring
@@ -19,7 +704,7 @@
  * date of if the window is not outputtable.
  */
 void
-GsSetClipWindow(GR_WINDOW *wp, MWCLIPREGION *userregion, int flags)
+GsSetClipWindow(GR_WINDOW *wp, MWCLIPREGION *userregion, int flags, /*REM*/MWRECT* RToClip)
 {
 	GR_WINDOW	*orgwp;		/* original window pointer */
 	GR_WINDOW	*pwp;		/* parent window */
@@ -204,3 +889,7 @@
 	 */
 	GdDestroyRegion(r);
 }
+
+#endif
+
+
